//=============================================================================
//  MuseScore
//
// Note names and fingerings for Trumpet Bb
// changable for other Brass
//
//  Contribution Artur Vil� Canal, Joachim Schmitz
//  Copyright (c) 2011 Karl Gerhards, (C)2008 Werner Schweer and others
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License version 2.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//=============================================================================

import QtQuick 2.0
import MuseScore 3.0

MuseScore {
   version: "3.0"
   description: "This plugin names notes and adds bariton fingering"
   menuPath: 'Plugins.Bariton fingering'
   onRun: {
      // gibt den Griff zur midi-Nummer
      function griff(midi) { 
         // change for other Brass
         midi = midi+6;
         // edit and uncomment for other Brass
         //midi = midi-20;
         // for 4 valves, usually 1+3 = 4
         switch (midi) {
            case 40: return "0"; break;
            case 41: return "1234"; break;
            case 42: return "134"; break; // C
            case 43: return "234"; break;
            case 44: return "124"; break;
            case 45: return "14"; break;
            case 46: return "123"; break;
            case 47: return "13"; break;
            case 48: return "23"; break;
            case 49: return "12"; break;
            case 50: return "1"; break;
            case 51: return "2"; break;
            case 52: return "0"; break;
            case 53: return "123"; break;
            case 54: return "13"; break; // c
            case 55: return "23"; break;
            case 56: return "12"; break;
            case 57: return "1"; break;
            case 58: return "2"; break;
            case 59: return "0"; break;
            case 60: return "23"; break;
            case 61: return "12"; break;
            case 62: return "1"; break;
            case 63: return "2"; break;
            case 64: return "0"; break;
            case 65: return "12"; break;
            case 66: return "1"; break; // c'
            case 67: return "2"; break;
            case 68: return "0"; break;
            case 69: return "1"; break;
            case 70: return "2"; break;
            case 71: return "0"; break;
            case 72: return "23"; break;
            case 73: return "12"; break;
            case 74: return "1"; break;
            case 75: return "2"; break;
            case 76: return "0"; break;
            case 77: return "12"; break;
            case 78: return "1"; break; // c"
            default: return "";		
         }
      }

      if (typeof curScore === 'undefined')
         qt.Quit();
	      
      // German Note Names
      var names = ["C","C#", "D","D#","E","F","F#","G","G#","A","B","H"];
      // American Note Names
      //var names = ["C","C#", "D","D#","E","F","F#","G","G#","A","A#","B"];
      // Italian Note Names
      //var names = ["do","do#", "re","re#","mi","fa","fa#","sol","sol#","la","la#","si"];
      var cursor   = curScore.newCursor();
      cursor.staffIdx = 0;
      cursor.voice = 0;
      cursor.rewind(0);  // set cursor to first chord/rest
      var CrLf = '\n';
      var textold = "xxx";
      while (cursor.segment) {
         if (cursor.element && cursor.element.type === Element.CHORD) {
            var text  = newElement(Element.STAFF_TEXT)
            text.text = griff(cursor.element.notes[0].pitch) + CrLf
                      + names[cursor.element.notes[0].pitch % 12];
            text.offsetY = 12;
            if (text.text != textold) cursor.add(text);
            textold = text.text;
         }
         cursor.next();
      }
      Qt.quit();
   }
}
